const
  infile = 'input.txt';
  outfile = 'output.txt';
  max = 200;
  mq = 20000;
  d : array [1..4,0..1] of integer = ((1,0),(-1,0),(0,1),(0,-1));

type
  TPoint = record
    x, y : byte;
  end;
  TQ = array [0..mq] of TPoint;
  PQ = ^TQ;

var
  fi, fo : text;
  field : array [0..max+1, 0..max+1] of byte;
  n, m : integer;

procedure ReadData;
var
  i, j : integer;
  s : string;
begin
  readln(fi, n, m);
  for i := 1 to n do begin
    readln(fi, s);
    for j := 1 to m do begin
      case s[j] of
        '.' : field[i,j] := 0;
        '*' : field[i,j] := 100;
      end;
    end;
  end;
  for i := 0 to m+1 do begin
    field[0,i] := 5;
    field[n+1,i] := 5;
  end;
  for i := 0 to n+1 do begin
    field[i,0] := 5;
    field[i,m+1] := 5;
  end;
end;

procedure Wave;
var
  Queue : PQ;
  i, qr, qw : integer;
  point, v : TPoint;
begin
  new(Queue);
  qr := 0; qw := 0;
  field[1,1] := 1;
  point.x := 1; point.y := 1;
  Queue^[qw] := point; qw := (qw + 1) mod mq;
  while (qr <> qw) do begin
    v := Queue^[qr]; qr := (qr + 1) mod mq;
    for i := 1 to 4 do begin
      point.x := v.x + d[i,0]; point.y := v.y + d[i,1];
      if (field[point.x, point.y] = 0) then begin
        field[point.x, point.y] := 1;
        Queue^[qw] := point; qw := (qw + 1) mod mq;
      end;
    end;
  end;
end;

procedure Count;
var
  i, j, k, yes : integer;
  p : TPoint;
  counter : longint;
begin
  counter := 0;
  for i := 1 to n do begin
    for j := 1 to m do begin
      if (field[i,j] = 100) then begin
        yes := 0;
        for k := 1 to 4 do begin
          yes := yes + ord(field[i+d[k,0], j+d[k,1]] = 1);
        end;
        if yes > 0 then counter := counter + 1;
      end;
    end;
  end;
  writeln(fo, counter);
end;

begin
  assign(fi, infile); assign(fo, outfile);
  reset(fi); rewrite(fo);
  ReadData;
  Wave;
  Count;
  close(fi); close(fo);
end.