#include <stdio.h>
#include <stdlib.h>

extern unsigned _stklen = 60000U;

struct TD
{
	long sum;
	int pos;
};
TD* arrs[5];


TD get_arr(long index)
{
	if(index < 7000)return arrs[0][index];
	else if(index < 14000)return arrs[1][index - 7000];
	else if(index < 21000)return arrs[2][index - 14000];
	else if(index < 28000)return arrs[3][index - 21000];
	else return arrs[4][index - 28000];
}

void set_arr(long index, TD value)
{
	if(index < 7000)arrs[0][index] = value;
	else if(index < 14000)arrs[1][index - 7000] = value;
	else if(index < 21000)arrs[2][index - 14000] = value;
	else if(index < 28000)arrs[3][index - 21000] = value;
	else arrs[4][index - 28000] = value;
}

void swap(long index1, long index2)
{
	TD x = get_arr(index1);
	set_arr(index1, get_arr(index2));
    set_arr(index2, x);
}


int comp(TD a, TD b)
{
	if (a.sum > b.sum) return 1;
	if (a.sum < b.sum) return -1;

	if (a.pos > b.pos) return 1;
	if (a.pos < b.pos) return -1;

	return 0;
}

TD t;
TD del;
int res;
void qsort(long M,long N)
{
	if(N<=M+1)return;
	long m=M,n=M,p=N;
	del = get_arr(M+random(N-M));
	while(n!=p)
	{
		t = get_arr(n);
		res = comp(t,del);
		if(res <= 0)
		{
			//putchar('!');
		}

		if ( res > 0 ) swap(n,--p);
		else if(res == 0)++n;
		else if(res < 0)swap(m++,n++);
	}
	if(N-p>m-M)
	{
		qsort(M,m);
		qsort(p,N);
	}
	else
	{
		qsort(p,N);
		qsort(M,m);
	}
}

long mid,left,right;
TD vl;
long search(long beg,long end,long val)
{
	while(beg < end)
	{
		mid = (beg + end) >> 1;
		vl = get_arr(mid);
		if( vl.sum == val ) return mid;

		if(vl.sum < val) beg = mid + 1;
		else end = mid;
	}
	return -1;
}


int main()
{
	freopen( "input.txt", "r", stdin );
	freopen( "output.txt", "w", stdout );

	long i;
	for(i=0;i<5;++i)
	{
		arrs[i] = new TD[7000];
		if(!arrs[i])
		{
			printf("Crash!!!\n");
			return 1;
		}
	}


	long M,S;
	long prev = 0;
	long CurLen = 0;
	long CurPos = 0;
	long MaxSum = 0;

	scanf("%ld %ld",&M,&S);
	TD Cur;
	Cur.pos = 1;
	Cur.sum = 0;
	set_arr(0, Cur);

	for(i=1;i<=M;++i)
	{
		long data;
		scanf("%ld",&data);
		prev += data;

		Cur.sum = prev;
		Cur.pos = i+1;

		set_arr(i, Cur);

		if (prev > MaxSum)
			MaxSum = prev;
	}
	qsort(0, M+1);
	for (i=0; i<M+1 ;i++)
	{
		TD This = get_arr(i);

		if (This.sum + S <= MaxSum)
		{
			int Ind = search(0, M+1, This.sum + S);

			if (Ind != -1)
			{
				TD A;
				while (Ind+1 <= M)
				{
					A = get_arr(Ind + 1);
					if (A.sum != This.sum + S) break;
					Ind++;
				}
				A = get_arr(Ind);

				if (A.pos - This.pos > 0 && A.pos - This.pos >= CurLen)
				{
					if (A.pos - This.pos > CurLen)
					{
						CurLen = A.pos - This.pos;
						CurPos = This.pos;
					}
					else
					{
						if (CurPos == 0 || CurPos > This.pos)
						{
							CurPos = This.pos;
						}
					}
				}
			}
		}
	}
	printf("%ld %ld\n", CurPos, CurLen);

	for(i=0;i<5;++i)
		delete[] arrs[i];

	fclose( stdout );
	fclose( stdin );
	return 0;
}