type
   TPole = array [1..8, 1..8] of integer;

var
   steps1: array [1..33] of record
      r, c: integer;
   end;
   i, j, k: integer;
   c: char;
   pole1: TPole;
   pole2: TPole;
   possible: array [1..32] of TPole;
   f: boolean;

function inside(ii, jj: integer): boolean;
begin
   inside := (ii >= 1) and (ii <= 8) and (jj >= 1) and (jj <= 8);
end;

procedure makePossible(i: integer; var pole: TPole);
var
   j, k: integer;
begin
   for j := 1 to 8 do
      for k := 1 to 8 do
         pole[j, k] := 0;
   for j := 1 to 8 do begin
      if (pole1[steps1[i].r, j] = 0) and (j <> steps1[i].c) then
         pole[steps1[i].r, j] := -1;
      if (pole1[j, steps1[i].c] = 0) and (j <> steps1[i].r) then
         pole[j, steps1[i].c] := -1;
   end;
   for j := 1 to 8 do begin
      for k := 1 to 8 do begin
         if (k = steps1[i].c) and (j = steps1[i].r) then
            continue;
         if (abs(j - steps1[i].r) = abs(k - steps1[i].c)) and
            (pole1[j, k] = 0) then
            pole[j, k] := -1;
      end;
   end;
end;

function find(ii: integer): boolean;
var
   i, j: integer;
begin
   find := false;
   if ii = 33 then begin
      find := true;
      exit;
   end;
   for i := 1 to 8 do
      for j := 1 to 8 do
         if (possible[ii][i, j] = -1) and
            (pole2[i, j] = 0) then begin
            pole2[i, j] := ii;
            if find(ii + 1) then begin
               find := true;
               exit;
            end;
            pole2[i, j] := 0;
         end;
end;

begin
   Assign(input, 'input.txt');
   Assign(output, 'output.txt');
   Reset(input);
   Rewrite(output);

   for i := 1 to 32 do begin
      read(c);
      steps1[i].r := ord(c) - ord('a') + 1;
      read(c);
      steps1[i].c := ord(c) - ord('0');
      read(c);
   end;
   steps1[33].c := steps1[1].c;
   steps1[33].r := steps1[1].r;

   for i := 1 to 8 do
      for j := 1 to 8 do begin
         pole1[i, j] := 0;
         pole2[i, j] := 0;
      end;

   for i := 1 to 32 do
      inc(pole1[steps1[i].r, steps1[i].c]);

   for i := 2 to 33 do
      makePossible(i, possible[i - 1]);

   find(1);
   for k := 1 to 32 do begin
      f := false;
      for i := 1 to 8 do begin
         for j := 1 to 8 do
            if pole2[i, j] = k then begin
               if k > 1 then
                  write(' ');
               write(chr(ord('a') + i - 1), j);
               f := true;
               break;
            end;
         if f then
            break;
      end;
   end;

   Close(input);
   Close(output);
end.