TYPE
    TSTACKITEM = record
               x, y : integer;
               end;
    TSTACK = array[1..40] of TSTACKITEM;
    TLINE = array[1..8] of boolean;
    TFIELD = array[1..8] of TLINE;

    TLINEI = array[1..8] of integer;
    TFIELDI = array[1..8] of TLINEI;

    TMASKS = array[1..32] of TFIELD;
    TNUMS  = array[1..32] of integer;

    TLINEGR = array[1..32] of boolean;
    TGRAPH = array[1..32] of TLINEGR;

    PQUEUEITEM = ^TQUEUEITEM;
    TQUEUEITEM = record
               n    : integer;
               s    : integer;
               next : PQUEUEITEM;
               end;

VAR
   first  : TSTACK;
   now    : TFIELD;
   num    : TFIELDI;
   masks  : TMASKS;

   Mx, My : TNUMS;
   Fx, Fy : TNUMS;
   graph  : TGRAPH;
   find   : integer;
   X, Y   : TNUMS;
   i, j   : integer;



PROCEDURE SEARCH;
          var
             top, bottom : PQUEUEITEM;

          PROCEDURE ADDQUEUE(n : integer; s : integer);
                    var
                       temp : PQUEUEITEM;
                    begin
                         New(temp);
                         temp^.n := n;
                         temp^.s := s;
                         temp^.next := NIL;
                         if bottom = NIL then
                            bottom := temp
                         else
                             top^.next := temp;
                         top := temp;
                    end;

          PROCEDURE DeleteQueue(var n : integer; var s : integer);
                    var
                       temp : PQUEUEITEM;
                    begin
                         temp := bottom;
                         n := bottom^.n;
                         s := bottom^.s;
                         bottom := bottom^.next;
                         Dispose(temp);
                    end;

          var
             n, s : integer;
             i, j : integer;

          begin
               top := NIL;
               bottom := NIL;
               for i := 1 to 32 do
                   Fx[i] := 0;
               for i := 1 to 32 do
                   Fy[i] := 0;
               for i := 1 to 32 do
                   if Mx[i] = 0 then
                      AddQueue(i, 1);
               find := 0;
               while (bottom <> NIL) and (find = 0) do
                     begin
                     DeleteQueue(n, s);
                     if s = 1 then
                        begin
                        for i := 1 to 32 do
                            if (graph[n][i]) and (Fy[i] = 0) then
                               begin
                               Fy[i] := n;
                               AddQueue(i, 2);
                               end;
                        end
                     else
                         begin
                         if My[n] = 0 then
                            find := n
                         else
                             begin
                             Fx[My[n]] := n;
                             AddQueue(My[n], 1);
                             end;
                         end;
                     end;
               while bottom <> NIL do
                     DeleteQueue(n, s);
          end;

PROCEDURE INCREASE;
          var
             s, n : integer;
             fn   : integer;
          begin
               n := find;
               s := 2;
               while n <> 0 do
                     begin
                     if s = 2 then
                        begin
                        fn := Fy[n];
                        if Mx[fn] <> 0 then
                           My[Mx[fn]] := 0;
                        Mx[fn] := n;
                        My[n] := fn;
                        s := 1;
                        n := fn;
                        end
                     else
                         begin
                         fn := Fx[n];
                         s := 2;
                         n := fn;
                         end;
                     end;
          end;

PROCEDURE WRITEFIELD(field : TFIELD);
          var
             i, j : integer;
          begin
               for i := 8 downto 1 do
                   begin
                   for j := 1 to 8 do
                       if field[i][j] then
                          Write('*')
                       else
                           Write(' ');
                   WriteLN;
                   end;
               WriteLN;
          end;

PROCEDURE QUEENMOVES(x, y : integer; var field : TFIELD);
          var
             i, j : integer;
             old : TFIELD;
          begin
               old := field;
               for i := 1 to 8 do
                   for j := 1 to 8 do
                       field[i][j] := FALSE;
               for i := 1 to 8 do
                   field[x][i] := old[x][i];
               for i := 1 to 8 do
                   field[i][y] := old[i][y];
               for i := -10 to 10 do
                   if (x + i <= 8) and (y + i <= 8) and (x + i >= 1) and (y + i >= 1) then
                      field[x + i][y + i] := old[x + i][y + i];
               for i := -10 to 10 do
                   if (x - i <= 8) and (y + i <= 8) and (x - i >= 1) and (y + i >= 1) then
                      field[x - i][y + i] := old[x - i][y + i];
          end;

PROCEDURE MAKEMASKS;
          var
             i, k, l : integer;
          begin
               for i := 1 to 32 do
                   begin
                   for k := 1 to 8 do
                       for l := 1 to 8 do
                           masks[i][k][l] := now[k][l];
                   QUEENMOVES(first[ (i - 1) mod 32 + 1].x, first[(i - 1) mod 32 + 1].y, masks[i]);
                   QUEENMOVES(first[i mod 32 + 1].x, first[i mod 32 + 1].y, masks[i]);
                   end;
          end;

PROCEDURE INPUTDATA;
          var
             i : integer;
             ch : char;
          begin
               Assign(input, 'input.txt');
               ReSet(input);
               for i := 1 to 32 do
                   begin
                   Read(ch);
                   while not (ch in ['a'..'h']) do
                         Read(ch);
                   first[i].x := Ord(ch) - Ord('a') + 1;
                   Read(ch);
                   while not (ch in ['1'..'8']) do
                         Read(ch);
                   first[i].y := Ord(ch) - Ord('1') + 1;
                   end;
               for i := 1 to 32 do
                   now[first[i].x][first[i].y] := FALSE;
               Close(input);
          end;

PROCEDURE MAKEGRAPH;
          var
             count : integer;
             i, j, k: integer;

          begin
               count := 0;
               for i := 1 to 8 do
                   for j := 1 to 8 do
                       if now[i][j] then
                          begin
                          Inc(count);
                          num[i][j] := count;
                          X[count] := i;
                          Y[count] := j;
                          end;
               for i := 1 to 32 do
                   for j := 1 to 32 do
                       graph[i][j] := FALSE;
               for i := 1 to 32 do
                   for j := 1 to 8 do
                       for k := 1 to 8 do
                           if masks[i][j][k] then
                              graph[i][ num[j][k] ] := TRUE;
          end;

PROCEDURE OUTPUTDATA;
          var
             i : integer;
          begin
               Assign(output, 'output.txt');
               ReWrite(output);
               for i := 1 to 32 do
                   begin
                   Write(Chr(X[Mx[i]] + Ord('a') - 1));
                   Write(Chr(Y[Mx[i]] + Ord('1') - 1));
                   Write(' ');
                   end;
               Close(output);
          end;

BEGIN
     for i := 1 to 8 do
         for j := 1 to 8 do
             now[i][j] := TRUE;
     INPUTDATA;
     MAKEMASKS;
     MAKEGRAPH;

     for i := 1 to 32 do
         Mx[i] := 0;
     for i := 1 to 32 do
         My[i] := 0;

     SEARCH;
     while find <> 0 do
           begin
           INCREASE;
           SEARCH;
           end;

     OUTPUTDATA;
END.